Unit grafika;

Interface
  Uses Typy,Graph,Crt;

   Procedure Inicializuj;
   Procedure NakresliIhrisko;
   Procedure OznamVysledok(Body:Vysledok);
   Procedure VymazPolicko(x,y:Integer);
   Procedure NakresliPolicko(x,y:Integer;h:integer;t:integer);
   Procedure VypisNoveBody(Body:Vysledok);
   Procedure KoniecTurnaja(Body:Vysledok);

Implementation

   Var Stare:Vysledok;
       i:Integer;

   Procedure Inicializuj;
     Var i,j:Integer;
     Begin
       DetectGraph(i,j); i:=9; j:=2;
       InitGraph(i,j,'');
       writeln(graphresult);
     End;

   {Iba okraje ihriska}
   Procedure NakresliIhrisko;
     Var i,j,t:Integer;
     Begin
       {Vymazeme obrazovku}
       SetBkColor(0);
       ClearDevice;
       {Nakreslime okraj}
       SetColor(15);
       Line(3,3,IhriskoX*4+4,3);
       Line(3,3,3,Ihriskoy*4+4);
       Line(IhriskoX*4+4,IhriskoY*4+4,IhriskoX*4+4,3);
       Line(IhriskoX*4+4,IhriskoY*4+4,3,Ihriskoy*4+4);
       SetColor(12);
       Line(2,2,IhriskoX*4+5,2);
       Line(2,2,2,Ihriskoy*4+5);
       Line(IhriskoX*4+5,IhriskoY*4+5,IhriskoX*4+5,2);
       Line(IhriskoX*4+5,IhriskoY*4+5,2,Ihriskoy*4+5);
       SetColor(15);
       Line(1,1,IhriskoX*4+6,1);
       Line(1,1,1,Ihriskoy*4+6);
       Line(IhriskoX*4+6,IhriskoY*4+6,IhriskoX*4+6,1);
       Line(IhriskoX*4+6,IhriskoY*4+6,1,Ihriskoy*4+6);
       For i:=1 To Hracov Do Stare[i]:=1;
     End;

   Procedure OznamVysledok(Body:Vysledok);
     Var g:Char;
         s:String;
     Begin
       SetFillStyle(SolidFill,7);
       Bar(23,30,460,280);
       For i:=1 To Hracov Do Begin
         Str(Body[i]:4,s);
         s:=Mena[i]+':'+s;
         SetTextStyle(DefaultFont,HorizDir,3);
         SetColor(Farby[i]+8);

         OuttextXY(68,70+(i-1)*40,s);
       End;
       repeat
         g:=Readkey;
       until g=' ';
     End;

   Procedure KoniecTurnaja(Body:Vysledok);
     Var g:Char;
         s,z:String;
         IND:Array[1..Hracov] Of Integer;
         i,j,k:Integer;

     Begin
       For i:=1 To Hracov DO IND[i]:=i;

       For i:=1 To Hracov-1 Do Begin
         For j:=i+1 To Hracov Do Begin
           If (Body[IND[i]]<Body[IND[j]]) Then Begin
             k:=IND[i]; IND[i]:=IND[j]; IND[j]:=k;
           End;
         End;
       End;

       SetFillStyle(SolidFill,7);
       Bar(13,30,474,280);

       SetTextStyle(DefaultFont,HorizDir,3);
       SetColor(0);
       OuttextXY(134,50,'Vysledky:');

       For i:=1 To Hracov Do Begin
         Str(i,z);
         Str(Body[i]:4,s);
         s:=z+'.'+' '+Mena[i]+':'+s;
         SetTextStyle(DefaultFont,HorizDir,3);
         SetColor(Farby[i]+8);

         OuttextXY(34,100+(i-1)*40,s);
       End;
       repeat
         g:=Readkey;
       until g=' ';
     End;

   Procedure VypisNoveBody(Body:Vysledok);
     Var i:Integer;
         s:String;
     Begin
       SetTextStyle(DefaultFont,HorizDir,1);
       For i:=1 To Hracov Do If (Stare[i]<>Body[i]) Then Begin
         SetColor(0);
         Str(Stare[i]:4,s);
         s:=Mena[i]+':'+s;
         OutTextXY(500,i*20,s);

         SetColor(Farby[i]+8);
         Str(Body[i]:4,s);
         s:=Mena[i]+':'+s;
         OutTextXY(500,i*20,s);

         Stare[i]:=Body[i];
       End;
     End;

   Procedure VymazPolicko(x,y:Integer);
     Begin
       SetColor(0);
       line(4*x+0,4*y+0,4*x+3,4*y+0);
       line(4*x+0,4*y+1,4*x+3,4*y+1);
       line(4*x+0,4*y+2,4*x+3,4*y+2);
       line(4*x+0,4*y+3,4*x+3,4*y+3);
     End;

   Procedure NakresliPolicko(x,y:Integer;h:integer;t:integer);
     Begin
       If ((t=Nic) Or (t=Jedlo)) Then Begin
         SetColor(15);
         If (t=Jedlo) Then Begin
           line(4*x+1,4*y+1,4*x+2,4*y+1);
           line(4*x+1,4*y+2,4*x+2,4*y+2);
         End;
       End Else Begin
         SetColor(Farby[h]+8);
         Case (t) Of
           Mravenko:Begin
             line(4*x+0,4*y+0,4*x+3,4*y+0);
             line(4*x+3,4*y+0,4*x+3,4*y+3);
             line(4*x+3,4*y+3,4*x+0,4*y+3);
             line(4*x+0,4*y+3,4*x+0,4*y+0);
           End;
           Bojovnik:Begin
             line(4*x+0,4*y+0,4*x+3,4*y+0);
             line(4*x+0,4*y+3,4*x+3,4*y+3);
             line(4*x+1,4*y+0,4*x+1,4*y+3);
             line(4*x+2,4*y+0,4*x+2,4*y+3);
           End;
           Robotnik:Begin
             line(4*x+0,4*y+0,4*x+3,4*y+3);
             line(4*x+3,4*y+0,4*x+0,4*y+3);
           End;
         End;
       End;
     End;

Begin
End.