  Unit hrac1;

  Interface
    Uses typy;

    Const Cislo=1;
          pi2=6.283;
          kotoc=0.04;
          kcukru=20;
          kzmensi=0.7;
          kpsz=2;
          kstoj=3;
          kpolom=15;
          kchodzacukrom=10;
          kutocenie=1.5;
          kkuprob=5;
          kkupboj=8;
          kzvacsi=1.75;

    Procedure Init(A:Mravenisko);
    Procedure Tahaj(M:Mravce;Body:Integer;Var Tah:Pohyb;Var Novy:Kupa);

  Implementation

    type nepriatelia=array[1..mravcov*4,1..2] of integer;
    type mravci=array[0..mravcov] of integer;
    type kruh=record
           sx,sy:integer;
           ar,br,ab,bb:real; {alfa, t.j. zakladny uhol,beta - uhol na dalsieho}
           ikk:real; {interny kruh - pomer polomerov}
           koef:real; {kolko mravcov tvori kruh relativne}
           cielx,ciely:integer;
           dan:integer;
           nep:nepriatelia;
           nn:integer;
           p:integer; {polomer}
           boj,rob:mravci;
         end;
    type cukor=array[1..kcukru,1..2] of integer;
    type uloha=record
                 r,cx,cy:integer; {r-robotnik;c-cukor}
               end;
    type ulohy=array[1..kcukru] of uloha;
    type obsadenie=array[1..mravcov] of boolean;
    type poloha=array[1..mravcov,1..3] of integer;

    Var
        D:Mravenisko;
        zk:kruh;
        bk,pma,izk:boolean;
        ck:cukor;
        ul:ulohy;
        obs:obsadenie;
        nul,nck:integer;
        pl:poloha;
        nocukor:integer;
        ntah:integer;

  function sgn(x:integer):integer;
  begin
    if x>0 then sgn:=1 else
    if x<0 then sgn:=-1 else sgn:=0;
  end;

  function vzdial(x1,y1,x2,y2:integer):integer;
  var
    a,b:integer;
  begin
    a:=(x1-x2); b:=(y1-y2);
    if (abs(a)>1000) or (abs(b)>1000) then begin
      vzdial:=10000; exit;
    end;
    a:=a*a; b:=b*b;
    a:=a+b;
    vzdial:=round(sqrt(a));
  end;

   procedure initkruh(var k:kruh);
   begin
     with k do begin
       sx:=d.x; sy:=d.y; p:=1; cielx:=sx; ciely:=sy;
       boj[0]:=0; rob[0]:=0; ab:=0; ar:=0; koef:=0.8; ikk:=0.5;
       dan:=0;
     end;
   end;

   procedure optimalner(var k:kruh);
   var
     aa,c:integer;
   begin
     with k do begin
       aa:=trunc(boj[0]*koef);
       if aa<>0 then begin
         c:=2*(dohlad-1)*aa;
         p:=trunc(c/pi2);
         bb:=pi2/aa;
         br:=pi2/rob[0];
       end;
     end;
   end;

    Procedure Init(A:Mravenisko);
      Var i:Integer;
      Begin
        pma:=false;
        d:=A;
        initkruh(zk);
        izk:=true;
        nck:=0; bk:=false;
        nul:=0; ntah:=0;
        nocukor:=20;
        fillchar(obs,sizeof(obs),0);
        for i:=1 to mravcov do begin
          pl[i,1]:=d.x; pl[i,2]:=d.y; pl[i,3]:=kstoj;
        end;
      End;

    Procedure Tahaj(M:Mravce;Body:Integer;Var Tah:Pohyb;Var Novy:Kupa);

   procedure initzkruh;
   var
     x:integer;
   begin
     with zk do begin
       for x:=1 to mravcov do if m[x].zivy then begin
         if m[x].typ=robotnik then begin
           inc(rob[0]); rob[rob[0]]:=x;
         end else begin
           inc(boj[0]); boj[boj[0]]:=x;
         end;
       end;
       optimalner(zk);
     end;
   end;

   procedure kontrolujtah(a:integer;var x,y:integer);
   var
     ix,iy:integer;
   begin
     if abs(x)+abs(y)<>2 then exit;
     ix:=m[a].x+x; iy:=m[a].y+y;
     if (ix>ihriskox) or (ix<1) then begin x:=0; exit; end;
     if (iy>ihriskoy) or (iy<1) then begin y:=0; exit; end;
     if m[a].vidi[x,y]<0 then begin
       if m[a].vidi[x,0]>=0 then y:=0 else x:=0;
     end;
   end;

   procedure tahrobotnika(f,vx,vy:integer);
   begin
     if m[f].nesie then begin
       if (abs(vx)>abs(vy)) and (m[f].vidi[sgn(vx),0] = 0) then begin
         tah[f].dx:=sgn(vx);
         tah[f].dy:=0;
       end else begin
         if m[f].vidi[0,sgn(vy)] = 0 then begin
           tah[f].dx:=0;
           tah[f].dy:=sgn(vy);
         end else begin
           tah[f].dx:=sgn(vx);
           tah[f].dy:=0;
         end;
       end;
     end else begin
       if (abs(vx)>abs(vy)) and ((m[f].vidi[sgn(vx),0] = 0) or (m[f].vidi[sgn(vx),0] = -1)) then begin
         tah[f].dx:=sgn(vx);
         tah[f].dy:=0;
       end else begin
         if ((m[f].vidi[0,sgn(vy)] = 0) or (m[f].vidi[0,sgn(vy)] = -1)) then begin
           tah[f].dx:=0;
           tah[f].dy:=sgn(vy);
         end else begin
           tah[f].dx:=sgn(vx);
           tah[f].dy:=0;
         end;
       end;
     end;
    end;

    procedure pohybkruh(var k:kruh);
    var
      f,vx,vy:integer;
      t,p2:real;
    begin
      with k do begin
        vx:=cielx-sx; vy:=ciely-sy;
        if abs(vx)>abs(vy) then sx:=sx+sgn(vx) else sy:=sy+sgn(vy);
        for f:=1 to trunc(boj[0]*koef) do begin
          t:=ab+(f-1)*bb;
          vx:=round(cos(t)*p+sx); vy:=round(sin(t)*p+sy);
          vx:=-m[boj[f]].x+vx; vy:=-m[boj[f]].y+vy;
          vx:=sgn(vx); vy:=sgn(vy);
          kontrolujtah(boj[f],vx,vy);
          tah[boj[f]].dx:=vx;
          tah[boj[f]].dy:=vy;
        end;
        p2:=p*ikk;
        for f:=1 to rob[0] do begin
          t:=ar+(f-1)*br;
          vx:=round(cos(t)*p2+sx); vy:=round(sin(t)*p2+sy);
          vx:=-m[rob[f]].x+vx; vy:=-m[rob[f]].y+vy;
          tahrobotnika(rob[f],VX,VY);
        end;
      end;
    end;

    procedure ubermravca(var k:kruh;f:integer);
    begin
      with k do begin
        if f<>boj[0] then move(boj[f+1],boj[f],(boj[0]-f)*sizeof(integer));
        dec(boj[0]);
        optimalner(k);
        if dan>0 then p:=round(p*kzmensi);
      end;
    end;

    procedure udrzkruh(var k:kruh);
    var
      f:integer;
    begin
      with k do begin
        ab:=ab+kotoc; ar:=ar-kotoc;
        if ab>pi2 then ab:=ab-pi2;
        if ar<0 then ar:=ar+pi2;
        if izk then begin initzkruh; izk:=false; end;
        f:=1;
        while (f<=boj[0]) do begin
          if not m[boj[f]].zivy then begin ubermravca(k,f); dec(f); end;
          inc(f);
        end;
        if p>30 then optimalner(k);
      end;
    end;

    procedure zaradcukor(x,y:integer);
    var
      f:integer;
    begin
      for f:=1 to nck do begin
        if (ck[f,1]=x) and (ck[f,2]=y) then exit;
      end;
      if nck<kcukru then begin
        inc(nck); ck[nck,1]:=x; ck[nck,2]:=y;
      end;
    end;

    procedure hladajcukor;
    var
      f,cx,cy,ax,ay,i,j:integer;
      l:boolean;
    begin
      for f:=1 to mravcov do if m[f].zivy then begin
        if nck=kcukru then exit; l:=false;
        for ay:=-dohlad to dohlad do begin
          for ax:=-dohlad to dohlad do begin
            if m[f].vidi[ax,ay]=jedlo then begin l:=true; cx:=ax; cy:=ay; end;
            if (abs(ax)<=dohlad-kpsz) and (abs(ay)<=dohlad-kpsz) then begin
              for i:=ax-kpsz to ax+kpsz do for j:=ay-kpsz to ay+kpsz do begin
                if m[f].vidi[i,j]=bojovnik then begin
                  l:=false; j:=ay+kpsz; i:=ax+kpsz;
                end;
              end;
            end;
            if l then begin zaradcukor(m[f].x+cx,m[f].y+cy); l:=false; end;
          end;
        end;
      end;
      if nck=0 then begin
        if (nocukor>0) and (zk.cielx=zk.sx) and (zk.ciely=zk.sy) then dec(nocukor);
      end else begin nocukor:=kchodzacukrom;
        zk.cielx:=zk.sx; zk.ciely:=zk.sy; zk.p:=round(zk.p*kzvacsi);
      end;
      if (nocukor=0) and (zk.cielx=zk.sx) and (zk.ciely=zk.sy) then begin
        with zk do begin
          cielx:=sx+random(40)-20; ciely:=sy+random(30)-15;
          if cielx<10 then cielx:=10; if ciely<10 then ciely:=10;
          if cielx>ihriskox-10 then cielx:=ihriskox-10;
          if ciely>ihriskoy-10 then ciely:=ihriskoy-10;
        end;
      end;
    end;

    procedure vymazcukor(s:integer);
    begin
      if s<>nck then move(ck[s+1],ck[s],2*sizeof(integer)*(nck-s));
      dec(nck);
    end;

    procedure vymazulohu(s:integer);
    begin
      obs[ul[s].r]:=false;
      if s<>nul then move(ul[s+1],ul[s],sizeof(uloha)*(nul-s));
      dec(nul);
    end;

    procedure zruscukor;
    var
      f,h,dx,dy,i,j:integer;
    begin
      f:=1;
      while (f<=nck) do begin
        for h:=1 to mravcov do if m[h].zivy then begin
          dx:=ck[f,1]-m[h].x; dy:=ck[f,2]-m[h].y;
          if (abs(dx)<=dohlad) and (abs(dy)<=dohlad) then begin
            if m[h].vidi[dx,dy]<>jedlo then begin vymazcukor(f); dec(f); end else begin
              if (abs(dx)<=dohlad-kpsz) and (abs(dy)<=dohlad-kpsz) then begin
                for i:=dx-kpsz to dx+kpsz do for j:=dy-kpsz to dy+kpsz do begin
                  if m[h].vidi[i,j]=bojovnik then begin
                    vymazcukor(f); dec(f); j:=dy+kpsz; i:=dx+kpsz;
                  end;
                end;
              end;
            end;
            h:=mravcov;
          end;
        end;
        inc(f);
      end;
    end;

    procedure zrusulohy;
    var
      f,h,dx,dy,i,j:integer;
    begin
      f:=1;
      while (f<=nul) do begin
        if not m[ul[f].r].zivy or m[ul[f].r].nesie then begin
          vymazulohu(f); dec(f);
        end else begin
          for h:=1 to mravcov do if m[h].zivy then begin
            dx:=ul[f].cx-m[h].x; dy:=ul[f].cy-m[h].y;
            if (abs(dx)<=dohlad) and (abs(dy)<=dohlad) then begin
              if m[h].vidi[dx,dy]<>-1 then begin vymazulohu(f); dec(f); end else begin
                if (abs(dx)<=dohlad-kpsz) and (abs(dy)<=dohlad-kpsz) then begin
                  for i:=dx-kpsz to dx+kpsz do for j:=dy-kpsz to dy+kpsz do begin
                    if m[h].vidi[i,j]=bojovnik then begin
                      vymazulohu(f); dec(f); j:=dy+kpsz; i:=dx+kpsz;
                    end;
                  end;
                end;
              end;
              h:=mravcov;
            end;
          end;
        end;
        inc(f);
      end;
    end;

    procedure priradulohy;
    var
      f,r:integer;
      vz:integer;
    begin
      r:=1;
      while ((nul<kcukru) and (nck>0) and (r<>0)) do begin
        r:=0;
        for f:=1 to mravcov do begin
          if (m[f].zivy) and (m[f].typ=robotnik) and not obs[f] and not m[f].nesie then begin
            if r<>0 then begin
              if vzdial(m[f].x,m[f].y,ck[1,1],ck[1,2])<vz then begin
                r:=f; vz:=vzdial(m[r].x,m[r].y,ck[1,1],ck[1,2]);
              end;
            end else begin
              r:=f; vz:=vzdial(m[r].x,m[r].y,ck[1,1],ck[1,2]);
            end;
          end;
        end;
        if r<>0 then begin
          obs[r]:=true;
          inc(nul);
          ul[nul].r:=r; ul[nul].cx:=ck[1,1]; ul[nul].cy:=ck[1,2];
          vymazcukor(1);
        end;
      end;
    end;

    procedure robulohy;
    var
      f,vx,vy:integer;
    begin
      for f:=1 to nul do begin
        vx:=ul[f].cx-m[ul[f].r].x; vy:=ul[f].cy-m[ul[f].r].y;
        tahrobotnika(ul[f].r,vx,vy);
      end;
    end;

    procedure plnydomov;
    var
      f,vx,vy:integer;
    begin
      for f:=1 to mravcov do if m[f].zivy and m[f].nesie then begin
        vx:=d.x-m[f].x; vy:=d.y-m[f].y;
        tahrobotnika(f,vx,vy);
      end;
    end;

    procedure obranakruhu(var k:kruh);
    var
      f,i,j:integer;
      nx,ny,kj:integer;
    begin
      with k do begin
        kj:=trunc(p*kutocenie); if kj<kpolom then kj:=kpolom;
        nn:=0;
        for f:=1 to boj[0] do begin
          for i:=-dohlad to dohlad do
          for j:=-dohlad to dohlad do begin
            if m[boj[f]].vidi[i,j]>0 then begin
              if dan=0 then begin
                dan:=1; nn:=0;
              end;
              nx:=m[boj[f]].x+i; ny:=m[boj[f]].y+j;
              if vzdial(nx,ny,sx,sy)<kj then begin
                inc(nn);
                nep[nn,1]:=nx; nep[nn,2]:=ny;
              end;
            end;
          end;
        end;
      end;
    end;

    procedure obrannypohyb(var k:kruh);
    var
      f,h,mi,miv:integer;
      vx,vy:integer;
      ma:mravci;
    begin
      fillchar(ma,sizeof(ma),0);
      with k do begin
        if dan=1 then begin p:=round(p*kzmensi); inc(dan); end;
        for h:=1 to boj[0] do begin
          if ma[h]=0 then begin
            mi:=0;
            for f:=1 to nn do begin
              if mi<>0 then begin
                if vzdial(m[boj[h]].x,m[boj[h]].y,nep[f,1],nep[f,2])<miv then begin
                  mi:=f; miv:=vzdial(m[boj[h]].x,m[boj[h]].y,nep[f,1],nep[f,2]);
                end;
              end else begin
                mi:=f; miv:=vzdial(m[boj[h]].x,m[boj[h]].y,nep[f,1],nep[f,2]);
              end;
            end;
            if mi<>0 then begin
              inc(ma[h]);
              vx:=sgn(nep[mi,1]-m[boj[h]].x); vy:=sgn(nep[mi,2]-m[boj[h]].y);
              kontrolujtah(boj[h],vx,vy);
              tah[boj[h]].dx:=vx; tah[boj[h]].dy:=vy;
            end;
          end;
        end;
      end;
    end;

    procedure psz;
    var
      f:integer;
      tx,ty,kx,ky:integer;
      je:boolean;
    begin
      for f:=1 to mravcov do if m[f].zivy and (m[f].typ=robotnik) then begin
        je:=false;
        for tx:=-kpsz to kpsz do for ty:=-kpsz to kpsz do begin
          if m[f].vidi[tx,ty]=bojovnik then begin
            je:=true; kx:=-tx; ky:=-ty; tx:=kpsz; ty:=kpsz;
          end;
        end;
        if je then begin
          tahrobotnika(f,kx,ky);
        end;
      end;
    end;

    procedure nestojdlho;
    var
      f:integer;
    begin
      for f:=1 to mravcov do begin
        if m[f].zivy and (m[f].x=pl[f,1]) and (m[f].y=pl[f,2]) then begin
          if pl[f,3]>0 then dec(pl[f,3]) else
          begin
            tah[f].dx:=integer(random(3))-1;
            tah[f].dy:=integer(random(3))-1;
            if m[f].typ=robotnik then begin
              case random(2) of
                0: tah[f].dx:=0;
                1: tah[f].dy:=0;
              end;
            end;
          end;
        end else begin pl[f,3]:=kstoj; pl[f,1]:=m[f].x; pl[f,2]:=m[f].y; end;
      end;
    end;

    procedure kupcotreba;
    var
      d1,d2:integer;
    begin
      if body>=4 then begin
        with zk do begin
          d1:=boj[0]-kkupboj;
          d2:=rob[0]-kkuprob;
          if (d1<0) or (d2<0) then begin
            if d2<d1 then novy:=robotnik else novy:=bojovnik;
            bk:=true;
          end;
        end;
      end;
    end;

    procedure zaradnoveho;
    var
      f:integer;
      c:mravci;
    begin
      fillchar(c,sizeof(c),0);
      for f:=1 to mravcov do begin
        if m[f].zivy then c[f]:=1;
      end;
      for f:=1 to zk.boj[0] do inc(c[zk.boj[f]]);
      for f:=1 to zk.rob[0] do inc(c[zk.rob[f]]);
      for f:=1 to mravcov do begin
        if c[f]=1 then begin
          if m[f].typ=robotnik then begin
            inc(zk.rob[0]); zk.rob[zk.rob[0]]:=f;
          end else begin
            inc(zk.boj[0]); zk.boj[zk.boj[0]]:=f;
          end;
          optimalner(zk);
          if zk.dan>0 then zk.p:=round(zk.p*kzmensi);
        end;
      end;
    end;

    procedure zozerhned;
    var
      f,l:integer;
    begin
      with zk do begin
        for f:=1 to boj[0] do begin
          l:=boj[f];
          if m[f].vidi[1,0]=jedlo then begin tah[f].dx:=1; tah[f].dy:=0; end else
          if m[f].vidi[-1,0]=jedlo then begin tah[f].dx:=-1; tah[f].dy:=0; end else
          if m[f].vidi[0,1]=jedlo then begin tah[f].dx:=0; tah[f].dy:=1; end else
          if m[f].vidi[0,-1]=jedlo then begin tah[f].dx:=0; tah[f].dy:=-1; end;
        end;
      end;
    end;

    procedure kruhzacukrom;
    var
      f,ch,vz:integer;
      pfg:real;
    begin
      if nul=0 then exit;
      with zk do begin
        ch:=0;
        for f:=1 to nul do begin
          if ch<>0 then begin
            if vz>vzdial(d.x,d.y,ul[f].cx,ul[f].cy) then begin
              ch:=f; vz:=vzdial(d.x,d.y,ul[f].cx,ul[f].cy);
            end;
          end else begin
            ch:=f; vz:=vzdial(d.x,d.y,ul[f].cx,ul[f].cy);
          end;
        end;
        pfg:=(p+4)/vz; if pfg>1 then pfg:=1;
        sx:=round(pfg*(d.x-ul[ch].cx)+ul[ch].cx);
        sy:=round(pfg*(d.y-ul[ch].cy)+ul[ch].cy);
      end;
    end;

      Begin
        kruhzacukrom;
        if bk then zaradnoveho;
        novy:=0;
        inc(ntah);
        if ntah>10 then zk.koef:=0.9;
        hladajcukor;
        zruscukor;
        priradulohy;
        zrusulohy;
        udrzkruh(zk);
        obranakruhu(zk);
        pohybkruh(zk);
        obrannypohyb(zk);
        robulohy;
        zozerhned;
        plnydomov;
        nestojdlho;
        psz;
        kupcotreba;
      End;

  End.

